from http import HTTPStatus
from typing import Any, cast
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.cws_error_dto import CwsErrorDTO
from ...types import Response


def _get_kwargs(
    item_id: str,
    *,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> dict[str, Any]:
    headers: dict[str, Any] = {}
    headers["Authorization"] = authorization

    _kwargs: dict[str, Any] = {
        "method": "delete",
        "url": "/dpi/shipping/v1/items/{item_id}".format(
            item_id=quote(str(item_id), safe=""),
        ),
    }

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> Any | CwsErrorDTO | None:
    if response.status_code == 200:
        response_200 = cast(Any, None)
        return response_200

    if response.status_code == 403:
        response_403 = CwsErrorDTO.from_dict(response.json())

        return response_403

    if response.status_code == 404:
        response_404 = CwsErrorDTO.from_dict(response.json())

        return response_404

    if response.status_code == 500:
        response_500 = CwsErrorDTO.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> Response[Any | CwsErrorDTO]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    item_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[Any | CwsErrorDTO]:
    """Delete Item

     Deletes the item for the specified item id. <br><br>This operation only works for items attached to
    orders that are in the OPEN state. Called on items of orders in the FINALIZED state leads to an 404
    error (an item with the desired attributes cannot be found).

    Args:
        item_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Any | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        item_id=item_id,
        authorization=authorization,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    item_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Any | CwsErrorDTO | None:
    """Delete Item

     Deletes the item for the specified item id. <br><br>This operation only works for items attached to
    orders that are in the OPEN state. Called on items of orders in the FINALIZED state leads to an 404
    error (an item with the desired attributes cannot be found).

    Args:
        item_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Any | CwsErrorDTO
    """

    return sync_detailed(
        item_id=item_id,
        client=client,
        authorization=authorization,
    ).parsed


async def asyncio_detailed(
    item_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[Any | CwsErrorDTO]:
    """Delete Item

     Deletes the item for the specified item id. <br><br>This operation only works for items attached to
    orders that are in the OPEN state. Called on items of orders in the FINALIZED state leads to an 404
    error (an item with the desired attributes cannot be found).

    Args:
        item_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Any | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        item_id=item_id,
        authorization=authorization,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    item_id: str,
    *,
    client: AuthenticatedClient | Client,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Any | CwsErrorDTO | None:
    """Delete Item

     Deletes the item for the specified item id. <br><br>This operation only works for items attached to
    orders that are in the OPEN state. Called on items of orders in the FINALIZED state leads to an 404
    error (an item with the desired attributes cannot be found).

    Args:
        item_id (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Any | CwsErrorDTO
    """

    return (
        await asyncio_detailed(
            item_id=item_id,
            client=client,
            authorization=authorization,
        )
    ).parsed
